@echo off
rem
echo CUSTMIZE.BAT - Current $Revision:   1.10  $
rem
if x%1 == x? goto help
if x%1 == x/? goto help
if x%1 == x-? goto help
if x%1 == x goto help
:scr_select
rem set sdk defaults
set P_STYP=V
set P_S=vga480
set P_P=p_mouse
set P_L=us

rem set most used case
set P_SET=EU
set P_KNUM=EU
set P_C=A_

rem set fonts for US
set P_KFONT=fhlv16
set P_SFONT=fblks16
set P_K=DONT_BUILD
rem check environment
if x%P_K% == xDONT_BUILD goto getparms
rem
rem unable to set all environment variables - signal error
rem
set P_STYP=
set P_S=
set P_P=
set P_L=
set P_SET=
set P_KNUM=
set P_C=
set P_KFONT=
set P_SFONT=
set P_K=
goto env_error

:getparms
rem
rem choices are att400 cga200 vga480 vga400 vga320 padsl zoomer
rem
if x%1 == xvga480 goto s_vga480
if x%1 == xVGA480 goto s_vga480
if x%1 == xvga400 goto s_vga400
if x%1 == xVGA400 goto s_vga400
if x%1 == xvga320 goto s_vga320
if x%1 == xVGA320 goto s_vga320
if x%1 == xcga200 goto s_cga200
if x%1 == xCGA200 goto s_cga200
if x%1 == xatt400 goto s_att400
if x%1 == xATT400 goto s_att400
if x%1 == xpadsl  goto s_padsl
if x%1 == xPADSL  goto s_padsl
if x%1 == xzoomer goto s_gzmr
if x%1 == xZOOMER goto s_gzmr
goto scr_error
:pen_select
rem
rem choices are :-
rem
rem p_mouse     p_m64x48    p_m64x20    p_pad       p_padsl     p_gazell
rem p_poqet     p_poqetp    p_wacom     p_325p      p_nec       p_ncr
rem p_dtr1      p_dyna      p_tusk      p_710t      p_ibm730    p_ibm750
rem p_gzmr
rem
rem or any other base filename for the pen driver.    e.g. -  pendrvr
rem FOR THE EXAMPLE :- internal\pendrvr.rsc and resfiles\pendrvr.res are reqd
rem
if x%2 == x goto pen_error
set P_P=%2
if not exist internal\%P_P%.rsc goto pen_rscerr
if not exist resfiles\%P_P%.res goto pen_reserr
goto lang_select

:lang_select
rem
rem choices are dn fc fr gr it nw sp tu uk us
rem
if x%3 == xdn goto l_dn
if x%3 == xDN goto l_dn
if x%3 == xfc goto l_fc
if x%3 == xFC goto l_fc
if x%3 == xfr goto l_fr
if x%3 == xFR goto l_fr
if x%3 == xgr goto l_gr
if x%3 == xGR goto l_gr
if x%3 == xit goto l_it
if x%3 == xIT goto l_it
if x%3 == xnw goto l_nw
if x%3 == xNW goto l_nw
if x%3 == xsp goto l_sp
if x%3 == xSP goto l_sp
if x%3 == xtu goto l_tu
if x%3 == xTU goto l_tu
if x%3 == xuk goto l_uk
if x%3 == xUK goto l_uk
if x%3 == xus goto l_us
if x%3 == xUS goto l_us
goto lang_error
:chr_select
rem
rem By default (if no param) use both upper and lower case handwriting data
if x%4 == x goto c_all
if x%4 == x-a goto c_all
if x%4 == x-A goto c_all
if x%4 == x-u goto c_upper
if x%4 == x-U goto c_upper
goto chr_error

rem NOTE - P_S should be limited to six (6) characters for s_??????.??? files
:s_padsl
set P_STYP=V
set P_S=padsl
goto pen_select
:s_gzmr
set P_STYP=H
set P_S=gzmr
goto pen_select
:s_att400
set P_S=att400
goto pen_select
:s_cga200
set P_STYP=C
set P_S=cga200
goto pen_select
:s_vga480
set P_S=vga480
goto pen_select
:s_vga400
set P_S=vga400
goto pen_select
:s_vga320
set P_STYP=H
set P_S=vga320
goto pen_select

rem NOTE - P_P should be limited to six (6) characters for p_??????.??? files
:p_gazell
set P_P=gazell
goto lang_select
:p_mouse
set P_P=mouse
goto lang_select
:p_pad
set P_P=pad
goto lang_select
:p_wacom
set P_P=wacom
goto lang_select
:p_dyna
set P_P=dyna
goto lang_select
:p_710t
set P_P=710t
goto lang_select
:p_poqet
set P_P=poqet
goto lang_select
:p_ncr
set P_P=ncr
goto lang_select

:l_dn
set P_L=dn
set P_KFONT=fhl16dn
set P_SFONT=fhl10dnb
goto chr_select
:l_fc
set P_L=fc
set P_SET=FC
set P_KFONT=fhl16cf
set P_SFONT=fblksf16
goto chr_select
:l_fr
set P_L=fr
set P_SFONT=fblksi16
goto chr_select
:l_gr
set P_L=gr
set P_SFONT=fblksi16
goto chr_select
:l_it
set P_L=it
set P_SFONT=fblksi16
goto chr_select
:l_nw
set P_L=nw
set P_KFONT=fhl16dn
set P_SFONT=fhl10dnb
goto chr_select
:l_sp
set P_L=sp
set P_SFONT=fblksi16
goto chr_select
:l_tu
set P_L=tu
set P_SET=TU
set P_KFONT=paloaltu
set P_SFONT=fremontu
goto chr_select
:l_uk
set P_L=uk
set P_SFONT=fblksi16
goto chr_select
:l_us
set P_L=us
set P_SET=US
set P_KNUM=US
set P_SFONT=fblks16
goto chr_select

:c_upper
set P_C=U_
:c_all

rem Fall through to build

:build
if x%5 == x-k set P_K=BUILD
if x%5 == x-K set P_K=BUILD
rem build the customized PenRight! API

if not x%DEBUGCUST% == xDEBUGCUST goto cpy_lres

echo rem Intermediate Customization Batch File for the following command line > $cust$.bat
echo rem >> $cust$.bat
echo rem screen driver parameter = %1 >> $cust$.bat
echo rem pen driver parameter = %2 >> $cust$.bat
echo rem language parameter = %3 >> $cust$.bat
echo rem charset range parameter = %4 >> $cust$.bat
echo rem keyboard force build parameter = %5 >> $cust$.bat
echo rem >> $cust$.bat
echo rem >> $cust$.bat
echo rem Derived environment variables are --- >> $cust$.bat
echo rem >> $cust$.bat
echo rem Screen Driver    - P_S = %P_S% >> $cust$.bat
echo rem Screen Lines V/C - P_STYP = %P_STYP% >> $cust$.bat
echo rem Pen Driver       - P_P = %P_P% >> $cust$.bat
echo rem Language         - P_L = %P_L% >> $cust$.bat
echo rem Char Range A/U   - P_C = %P_C% >> $cust$.bat
echo rem Keyboard Build   - P_K = %P_K% >> $cust$.bat
echo rem Alpha Char Set   - P_SET = %P_SET% >> $cust$.bat
echo rem Numeric Char Set - P_KNUM = %P_KNUM% >> $cust$.bat
echo rem Keyboard Font    - P_KFONT = %P_KFONT% >> $cust$.bat
echo rem System Font      - P_SFONT = %P_SFONT% >> $cust$.bat
echo rem >> $cust$.bat
echo rem >> $cust$.bat
echo rem Commands that will be issued are --- >> $cust$.bat
echo rem >> $cust$.bat
echo copy resfiles\L_API_%P_L%.res internal\language.res >> $cust$.bat
echo copy internal\%P_SFONT%.fnt internal\systmfnt.fnt >> $cust$.bat
goto bld_kbd

:cpy_lres
copy resfiles\L_API_%P_L%.res internal\language.res
copy internal\%P_SFONT%.fnt internal\systmfnt.fnt

:bld_kbd
if not x%P_K% == xBUILD goto bld_api
if not x%DEBUGCUST% == xDEBUGCUST goto bldkbdndgb

echo frmbuild internal\kba_%P_STYP%_%P_L%.frm >> $cust$.bat
echo frmbuild internal\kbm_%P_STYP%_US.frm >> $cust$.bat
echo frmbuild internal\kbn_%P_STYP%_%P_KNUM%.frm >> $cust$.bat
echo copy internal\kba_%P_STYP%_%P_L%.rsc internal\kbalpha%P_STYP%.rsc >> $cust$.bat
echo copy internal\kbm_%P_STYP%_US.rsc internal\kbmin%P_STYP%.rsc >> $cust$.bat
echo copy internal\kbn_%P_STYP%_%P_KNUM%.rsc internal\kbnum%P_STYP%.rsc >> $cust$.bat
echo copy internal\kba_%P_STYP%_%P_L%.pcx internal\kbalpha%P_STYP%.pcx >> $cust$.bat
echo copy internal\kbm_%P_STYP%_US.pcx internal\kbmin%P_STYP%.pcx >> $cust$.bat
echo copy internal\kbn_%P_STYP%_%P_KNUM%.pcx internal\kbnum%P_STYP%.pcx >> $cust$.bat
echo copy internal\%P_KFONT%.fnt internal\kbfldfnt.fnt >> $cust$.bat
echo rem copy resfiles\kbr_%P_STYP%bld.res .\kbrbuild.res >> $cust$.bat
echo rscbuild kbr_%P_STYP%bld.res internal\kbd_%P_STYP%_%P_L%.rsc error.h -h internal\sysrsc.h >> $cust$.bat
goto bld_api

:bldkbdndgb
frmbuild internal\kba_%P_STYP%_%P_L%.frm
frmbuild internal\kbm_%P_STYP%_US.frm
frmbuild internal\kbn_%P_STYP%_%P_KNUM%.frm
copy internal\kba_%P_STYP%_%P_L%.rsc internal\kbalpha%P_STYP%.rsc
copy internal\kbm_%P_STYP%_US.rsc internal\kbmin%P_STYP%.rsc
copy internal\kbn_%P_STYP%_%P_KNUM%.rsc internal\kbnum%P_STYP%.rsc
copy internal\kba_%P_STYP%_%P_L%.pcx internal\kbalpha%P_STYP%.pcx
copy internal\kbm_%P_STYP%_US.pcx internal\kbmin%P_STYP%.pcx
copy internal\kbn_%P_STYP%_%P_KNUM%.pcx internal\kbnum%P_STYP%.pcx
copy internal\%P_KFONT%.fnt internal\kbfldfnt.fnt
rem copy resfiles\kbr_%P_STYP%bld.res .\kbrbuild.res
rscbuild kbr_%P_STYP%bld.res internal\kbd_%P_STYP%_%P_L%.rsc error.h -h internal\sysrsc.h

:bld_api
if not x%DEBUGCUST% == xDEBUGCUST goto bldapindbg

echo copy resfiles\S_%P_S%.res internal\screen.res >> $cust$.bat
echo copy resfiles\%P_P%.res internal\pen.res >> $cust$.bat
echo copy resfiles\HWR_%P_C%%P_SET%.res internal\charset.res >> $cust$.bat
echo copy resfiles\KBD_%P_STYP%_%P_L%.res internal\keyboard.res >> $cust$.bat
echo copy internal\penr!api.exe .\penr!api.exe >> $cust$.bat
echo rscbuild penright.res penr!api.exe error.h -h internal\sysrsc.h >> $cust$.bat
echo rscbuild penright.res penright.rsc error.h -h internal\sysrsc.h >> $cust$.bat
goto end

:bldapindbg
copy resfiles\S_%P_S%.res internal\screen.res
copy resfiles\%P_P%.res internal\pen.res
copy resfiles\HWR_%P_C%%P_SET%.res internal\charset.res
copy resfiles\KBD_%P_STYP%_%P_L%.res internal\keyboard.res
copy internal\penr!api.exe .\penr!api.exe
rscbuild penright.res penr!api.exe error.h -h internal\sysrsc.h
rscbuild penright.res penright.rsc error.h -h internal\sysrsc.h

goto end

:env_error
echo ERROR - NOT ENOUGH ENVIRONMENT SPACE!! Use the shell= line in CONFIG.SYS
echo                                        to increase environment space.
goto help
:scr_error
echo ERROR - SCREEN DRIVER '%1' NOT SUPPORTED !!
goto help
:pen_error
echo ERROR - NO PEN DRIVER SPECIFIED !!
goto help
:pen_reserr
echo ERROR - NO PEN DRIVER RESOURCE DESCRIPTION FILE - resfiles\%2.res !!
goto help
:pen_rscerr
echo ERROR - NO PEN DRIVER RESOURCE - internal\%2.rsc !!
goto help
:lang_error
echo ERROR - LANGUAGE - '%3' NOT SUPPORTED !!
goto help
:chr_error
echo ERROR - INVALID HANDWRITING CASE !! Your 4th parameter '%4' is not valid.
rem Fall through to help
:help
echo usage:     CUSTMIZE SCR_DRV PEN_DRV LANG [-a/u [-k]]
echo .
echo CUSTMIZE customizes the PenRight! API TSR program with the chosen screen
echo driver, pen driver and language dependant keyboard code resource.
echo The required parameters should be one each from the three lists below.
echo .
echo  SCR_DRV              PEN_DRV                               LANG
echo  =======   ==============================    ==================================
echo  att400    p_mouse    p_m64x20   p_m64x48    dn (Danish)        nw (Norwegian)
echo  cga200    p_pad      p_padsl    p_gazell    fc (French-Canada) sp (Spanish)
echo  vga320    p_poqet    p_poqetp   p_wacom     fr (French)        tu (Turkish)
echo  vga400    p_325p     p_nec      p_ncr       gr (German)        uk (English UK)
echo  vga480    p_dtr1     p_dyna     p_tusk      it (Italian)       us (English US)
echo  zoomer    p_710t     p_ibm730   p_ibm750
echo  padsl     p_gzmr                        
echo .
echo Optional parameters - MUST BE ENTERED IN THE FOLLOWING ORDER!!
echo -------------------
echo  -a/u  -a = ALL characters recognized OR -u = UPPER case only recognized
echo  -k    Rebuild the keyboard code resource for the language specified
echo        NOTE: The 4th parameter SHOULD BE -a or -u when -k is the 5th !!
echo READ CUSTMIZE.TXT for information on adding other 3rd party pen drivers.
:end
